// subPackage/page/pages/couponCenterInfo/couponCenterInfo.js
const wxService = require('../../../../utils/wxService')
const util = require('../../../../utils/util')
wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    activityId : null,
    activityInfo : {},
    showDialog : false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let id = options.id;
    this.data.activityId = id;
    this.getACtivityInfo();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  //获取活动详情
  getACtivityInfo(){
    wxService.post(`/coupon/couponCenterActivity/buyer/getDetail?id=${this.data.activityId}`).then(res => {
      if(res){
        let obj = res.data.data ? res.data.data : null;
        if (obj){
          let arr  = obj.definition ? JSON.parse(obj.definition) : [];
          obj.desc = arr.filter(item => item.type == 2);
          obj.hasExpDate = arr.filter(item => item.type == 1).length > 0 ;
          this.data.activityInfo = obj;
          //判断老活动
          if(this.data.activityInfo.couponList){
            this.data.activityInfo.isStart = util.compareCurrentDate(obj.startTime);
          }
          else{
            this.data.activityInfo.isStart = true;
          }
          
          this.setData({
            activityInfo: this.data.activityInfo
          });
        }
      }
    })
  },

  //领取优惠券
  onTapGetCoupon(){
    wx.showLoading({
      title: '领取中..',
    });
    let id = this.data.activityId;
    let isStart = this.data.activityInfo.isStart;
    console.log(isStart)
    //判断是不是老活动
    if(!this.data.activityInfo.couponList){
      this.getCoupon(id);
      return ;
    }

    if(isStart){
      this.getCoupon(id);
    }
    else{
      //立即预约
      this.orderCouponNow(id);
    }
    
  },

  //立即；领取
  getCoupon(id){
    wxService.post(`/coupon/couponCenterActivity/buyer/coupon/draw?id=${id}`).then(res => {
      wx.hideLoading();
      if (res) {
        if (res.data.result == 0) {
          //判断是不是老数据
          if(!this.data.activityInfo.couponList){
            wx.showToast({
              title: '领取成功',
            });
          }
          else{
            this.data.showDialog =  true;
            this.setData({
              showDialog : true
            });
          }
        }
        else {
          wx.showToast({
            title: '领取失败，请稍后再试',
            icon: 'none'
          });
        }
      }
    });
  },
  //立即预约
  orderCouponNow(id){
    let baseUserInfo = wx.getStorageSync('_baseUserInfo');
    wxService.post(`${'/merchant/message/wxSubMsgMapping/getListByParams'}`, {
      scenarioIds: ['usernoticeappointment'],
      sourceFrom: 2,
      switchType: 3
    }).then(res => {
      let tempArr = res.data.data ? res.data.data : [];
      let tempids = [];
      tempArr.map(item => {
        tempids.push(item.templateId);
      });
      wx.requestSubscribeMessage({
        tmplIds: tempids,
        success: (res) => {
          for (let i = 0; i < tempArr.length; i++) {
            wxService.post(`${'/merchant/message/wxSubMsgSubscride/member/subscribe'}`, {
              businessId: id,
              memberId: baseUserInfo.memberId,
              scenarioId: tempArr[i].scenarioId,
              templateId: tempArr[i].templateId
            }).then(resp => { });
          }
          if (tempids.length > 0) {
            let status = res[tempids[0]];
            if (status == 'accept') {
              this.getACtivityInfo();
              wx.showToast({
                title: '预约成功',
              })
            }
          }
        },
        complete: (res) => { }
      })
    }).catch(err => { })
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    let url = this.data.activityInfo.listPicture ? this.data.activityInfo.listPicture : 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png';
    return {
      title: `我分享给你一张“${this.data.activityInfo.couponName}”的优惠券，赶快领取吧~`,
      path: `/subPackage/page/pages/couponCenterInfo/couponCenterInfo?id=${this.data.activityId}`,
      imageUrl: url, // 可以更换分享的图片
    }
  }
})