// subPackage/page/pages/couponCenterInfo/couponCenterInfo.js
const app = getApp();
const wxService = require('../../../../utils/wxService')
const util = require('../../../../utils/util')
wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    activityId : null,
    activityInfo : {},
    showDialog : false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let id = options.id;
    if(id){
      this.data.activityId = id;
      this.getPayCardInfo();
    }
  },

  //获取支付券详情
  getPayCardInfo(){
    wxService.get(`/coupon/wechatCouponInfo/get/${this.data.activityId}`).then(res => {
      if(res){
        let obj = res.data.data ? res.data.data : null;
        if (obj){
          let detailInfo = obj.detailInfo ? JSON.parse(obj.detailInfo) : [];
          this.data.activityInfo = obj;
          this.data.activityInfo.desc = detailInfo;

          this.setData({
            activityInfo : this.data.activityInfo
          });
        }
      }
    })
  },

  //领取优惠券
  onTapGetCoupon(){
    wx.showLoading({
      title: '领取中..',
    });
    
    //调用接口领取
    let wechatCouponSetId = this.data.activityInfo.id;
    wxService.get(`/coupon/wechatCoupon/get?wechatCouponSetId=${wechatCouponSetId}`).then(res => {
      if(res){
        if(res.data.result == 0){
          wx.showModal({
            title: '领取成功提示',
            content: '领取成功，是否到我的优惠券中查看？',
            showCancel: true,
            cancelText: '取消',
            confirmText: '确认',
            confirmColor: app.globalData.themeColor,
            success: function (modalRes) {
              if (modalRes.confirm) {
                wx.navigateTo({
                  url: '/pages/coupons/coupons',
                });
              }
            }
          });
        }
      }
    });
  },


  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    let url = this.data.activityInfo.activityImgUrl ? this.data.activityInfo.activityImgUrl : 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png';
    return {
      title: `我分享给你一张“${this.data.activityInfo.couponName}”的支付券，赶快领取吧~`,
      path: `/subPackageA/page/pages/payCardInfo/payCardInfo?id=${this.data.activityId}`,
      imageUrl: url, // 可以更换分享的图片
    }
  }
});